-----------------
-- HTML parser --
-----------------

HTMLdocument = class()

HTMLdocument.tagtype = {html=true, head=true, body=true, title=true, b=true, i=true, u=true, br=false, hr=false, h1=true, h2=true, h3=true, h4=true, h5=true, h6=true, pre=true}

function HTMLdocument:init(src)
	self.source = src
	self.htmltree = HTMLobject(nil, "root")
	self.taglist = {}
end

function isTag(block)
	if block:sub(1,1) == "<" and block:sub(-1,-1) == ">" then
		return block:sub(2,-2)
	else
		return false
	end
end

function HTMLdocument:parse()
	local div = self.source:devide("<[^<>]*>")
	local ctag = self.htmltree
	
	
	for _, block in ipairs(div) do
		local data = isTag(block)
		
		if data then
			local tag = data:split(" ")[1]:lower()
			if tag:sub(-1,-1) == "/" then tag = tag:sub(1,-2) end
			
			if tag:sub(1,1) == "/" then
				if HTMLdocument.tagtype[tag:sub(2,-1)] and ctag.parent then
					ctag = ctag.parent
				end
			else
				
				local tagtable = HTMLobjects[tag](ctag, tag)
				table.insert(ctag.childs, tagtable)
				
				self.taglist[tag] = self.taglist[tag] or {}
				table.insert(self.taglist[tag], tagtable)
				if HTMLdocument.tagtype[tag] then ctag=tagtable end
			end
		else
			local s, e = block:find("[\r\n]+")
			if not (s == 1 and e == #block) then
				if ctag.tagtype ~= "pre" then block=block:gsub("%s+", " "):gsub("^%s","") end
				if block ~= "" then
					table.insert(ctag.childs, TextNode(ctag, block))
				end
			end
		end
	end
	
	return self.htmltree
end

function HTMLdocument:getElementsByTagName(tag)
	return self.taglist[tag:lower()] or {}
end

function HTMLdocument:paint(gc)
	gc:setColorRGB(0,0,0)
	gc:fillRect(0,0,pW,pH)
	gc:setColorRGB(255,255,255)
	self:getElementsByTagName("body")[1]:paint(gc, 0, 0, "r", 9, 0)
end
